import pygame
import math

class Moth:
    def __init__( self, start_pos, end_pos, icon ):
        
        self.position = start_pos
        self.radius = min( icon.get_rect().width, icon.get_rect().height )
        vector_x = end_pos[0]-start_pos[0]
        vector_y = end_pos[1]-start_pos[1]
        norm = math.sqrt( vector_x*vector_x + vector_y*vector_y )
        self.diff_x = vector_x / norm
        self.diff_y = vector_y / norm
        self.movement_speed = 1.0
        self.frames_per_stun = 90
        self.stunned = 0
        
        self.direction_degree = math.degrees( math.atan(self.diff_y/self.diff_x) )
        #self.direction_degree = 0.0
        self.rotated_icon = pygame.transform.rotate( icon, 270-self.direction_degree )
        self.draw_position = ( int(start_pos[0]), int(start_pos[1]) )
        
        return
    
    def update( self ):
        if self.stunned is 0:
            self.position = ( self.position[0]+self.diff_x*self.movement_speed, self.position[1]+self.diff_y*self.movement_speed )
            self.draw_position = ( int(self.position[0]), int(self.position[1]) )
        else:
            self.stunned = self.stunned - 1
        return
    
    def stun( self ):
        self.stunned = self.frames_per_stun
        return
    
    def draw( self, surface ):
        # body
        upperleft = (self.draw_position[0]-self.rotated_icon.get_rect().width/2,self.draw_position[1]-self.rotated_icon.get_rect().height/2)
        lowerright = (self.draw_position[0]+self.rotated_icon.get_rect().width/2,self.draw_position[1]+self.rotated_icon.get_rect().height/2)
        surface.blit( self.rotated_icon, ( upperleft, lowerright ) )
        return
    